#
# This file is part of ibus-bogo-python project.
#
# Copyright (C) 2012 Long T. Dam <longdt90@gmail.com>
# Copyright (C) 2012-2013 Trung Ngo <ndtrung4419@gmail.com>
# Copyright (C) 2013 Duong H. Nguyen <cmpitg@gmail.com>
#
# ibus-bogo-python is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# ibus-bogo-python is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with ibus-bogo-python.  If not, see <http://www.gnu.org/licenses/>.
#

# Taken from X11's keysymsdef.h
# TODO: This is ridiculous. We need some form of more automatic transforming.

mapping = {
	"Ạ" : 0x1001ea0,  # U+1EA0 LATIN CAPITAL LETTER A WITH DOT BELOW
	"ạ" : 0x1001ea1,  # U+1EA1 LATIN SMALL LETTER A WITH DOT BELOW
	"Ả" : 0x1001ea2,  # U+1EA2 LATIN CAPITAL LETTER A WITH HOOK ABOVE
	"ả" : 0x1001ea3,  # U+1EA3 LATIN SMALL LETTER A WITH HOOK ABOVE
	"Ấ" : 0x1001ea4,  # U+1EA4 LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND ACUTE
	"ấ" : 0x1001ea5,  # U+1EA5 LATIN SMALL LETTER A WITH CIRCUMFLEX AND ACUTE
	"Ầ" : 0x1001ea6,  # U+1EA6 LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND GRAVE
	"ầ" : 0x1001ea7,  # U+1EA7 LATIN SMALL LETTER A WITH CIRCUMFLEX AND GRAVE
	"Ẩ" : 0x1001ea8,  # U+1EA8 LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND HOOK ABOVE
	"ẩ" : 0x1001ea9,  # U+1EA9 LATIN SMALL LETTER A WITH CIRCUMFLEX AND HOOK ABOVE
	"Ẫ" : 0x1001eaa,  # U+1EAA LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND TILDE
	"ẫ" : 0x1001eab,  # U+1EAB LATIN SMALL LETTER A WITH CIRCUMFLEX AND TILDE
	"Ậ" : 0x1001eac,  # U+1EAC LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND DOT BELOW
	"ậ" : 0x1001ead,  # U+1EAD LATIN SMALL LETTER A WITH CIRCUMFLEX AND DOT BELOW
	"Ắ" : 0x1001eae,  # U+1EAE LATIN CAPITAL LETTER A WITH BREVE AND ACUTE
	"ắ" : 0x1001eaf,  # U+1EAF LATIN SMALL LETTER A WITH BREVE AND ACUTE
	"Ằ" : 0x1001eb0,  # U+1EB0 LATIN CAPITAL LETTER A WITH BREVE AND GRAVE
	"ằ" : 0x1001eb1,  # U+1EB1 LATIN SMALL LETTER A WITH BREVE AND GRAVE
	"Ẳ" : 0x1001eb2,  # U+1EB2 LATIN CAPITAL LETTER A WITH BREVE AND HOOK ABOVE
	"ẳ" : 0x1001eb3,  # U+1EB3 LATIN SMALL LETTER A WITH BREVE AND HOOK ABOVE
	"Ẵ" : 0x1001eb4,  # U+1EB4 LATIN CAPITAL LETTER A WITH BREVE AND TILDE
	"ẵ" : 0x1001eb5,  # U+1EB5 LATIN SMALL LETTER A WITH BREVE AND TILDE
	"Ặ" : 0x1001eb6,  # U+1EB6 LATIN CAPITAL LETTER A WITH BREVE AND DOT BELOW
	"ặ" : 0x1001eb7,  # U+1EB7 LATIN SMALL LETTER A WITH BREVE AND DOT BELOW
	"Ẹ" : 0x1001eb8,  # U+1EB8 LATIN CAPITAL LETTER E WITH DOT BELOW
	"ẹ" : 0x1001eb9,  # U+1EB9 LATIN SMALL LETTER E WITH DOT BELOW
	"Ẻ" : 0x1001eba,  # U+1EBA LATIN CAPITAL LETTER E WITH HOOK ABOVE
	"ẻ" : 0x1001ebb,  # U+1EBB LATIN SMALL LETTER E WITH HOOK ABOVE
	"Ẽ" : 0x1001ebc,  # U+1EBC LATIN CAPITAL LETTER E WITH TILDE
	"ẽ" : 0x1001ebd,  # U+1EBD LATIN SMALL LETTER E WITH TILDE
	"Ế" : 0x1001ebe,  # U+1EBE LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND ACUTE
	"ế" : 0x1001ebf,  # U+1EBF LATIN SMALL LETTER E WITH CIRCUMFLEX AND ACUTE
	"Ề" : 0x1001ec0,  # U+1EC0 LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND GRAVE
	"ề" : 0x1001ec1,  # U+1EC1 LATIN SMALL LETTER E WITH CIRCUMFLEX AND GRAVE
	"Ể" : 0x1001ec2,  # U+1EC2 LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND HOOK ABOVE
	"ể" : 0x1001ec3,  # U+1EC3 LATIN SMALL LETTER E WITH CIRCUMFLEX AND HOOK ABOVE
	"Ễ" : 0x1001ec4,  # U+1EC4 LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND TILDE
	"ễ" : 0x1001ec5,  # U+1EC5 LATIN SMALL LETTER E WITH CIRCUMFLEX AND TILDE
	"Ệ" : 0x1001ec6,  # U+1EC6 LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND DOT BELOW
	"ệ" : 0x1001ec7,  # U+1EC7 LATIN SMALL LETTER E WITH CIRCUMFLEX AND DOT BELOW
	"Ỉ" : 0x1001ec8,  # U+1EC8 LATIN CAPITAL LETTER I WITH HOOK ABOVE
	"ỉ" : 0x1001ec9,  # U+1EC9 LATIN SMALL LETTER I WITH HOOK ABOVE
	"Ị" : 0x1001eca,  # U+1ECA LATIN CAPITAL LETTER I WITH DOT BELOW
	"ị" : 0x1001ecb,  # U+1ECB LATIN SMALL LETTER I WITH DOT BELOW
	"Ọ" : 0x1001ecc,  # U+1ECC LATIN CAPITAL LETTER O WITH DOT BELOW
	"ọ" : 0x1001ecd,  # U+1ECD LATIN SMALL LETTER O WITH DOT BELOW
	"Ỏ" : 0x1001ece,  # U+1ECE LATIN CAPITAL LETTER O WITH HOOK ABOVE
	"ỏ" : 0x1001ecf,  # U+1ECF LATIN SMALL LETTER O WITH HOOK ABOVE
	"Ố" : 0x1001ed0,  # U+1ED0 LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND ACUTE
	"ố" : 0x1001ed1,  # U+1ED1 LATIN SMALL LETTER O WITH CIRCUMFLEX AND ACUTE
	"Ồ" : 0x1001ed2,  # U+1ED2 LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND GRAVE
	"ồ" : 0x1001ed3,  # U+1ED3 LATIN SMALL LETTER O WITH CIRCUMFLEX AND GRAVE
	"Ổ" : 0x1001ed4,  # U+1ED4 LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND HOOK ABOVE
	"ổ" : 0x1001ed5,  # U+1ED5 LATIN SMALL LETTER O WITH CIRCUMFLEX AND HOOK ABOVE
	"Ỗ" : 0x1001ed6,  # U+1ED6 LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND TILDE
	"ỗ" : 0x1001ed7,  # U+1ED7 LATIN SMALL LETTER O WITH CIRCUMFLEX AND TILDE
	"Ộ" : 0x1001ed8,  # U+1ED8 LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND DOT BELOW
	"ộ" : 0x1001ed9,  # U+1ED9 LATIN SMALL LETTER O WITH CIRCUMFLEX AND DOT BELOW
	"Ớ" : 0x1001eda,  # U+1EDA LATIN CAPITAL LETTER O WITH HORN AND ACUTE
	"ớ" : 0x1001edb,  # U+1EDB LATIN SMALL LETTER O WITH HORN AND ACUTE
	"Ờ" : 0x1001edc,  # U+1EDC LATIN CAPITAL LETTER O WITH HORN AND GRAVE
	"ờ" : 0x1001edd,  # U+1EDD LATIN SMALL LETTER O WITH HORN AND GRAVE
	"Ở" : 0x1001ede,  # U+1EDE LATIN CAPITAL LETTER O WITH HORN AND HOOK ABOVE
	"ở" : 0x1001edf,  # U+1EDF LATIN SMALL LETTER O WITH HORN AND HOOK ABOVE
	"Ỡ" : 0x1001ee0,  # U+1EE0 LATIN CAPITAL LETTER O WITH HORN AND TILDE
	"ỡ" : 0x1001ee1,  # U+1EE1 LATIN SMALL LETTER O WITH HORN AND TILDE
	"Ợ" : 0x1001ee2,  # U+1EE2 LATIN CAPITAL LETTER O WITH HORN AND DOT BELOW
	"ợ" : 0x1001ee3,  # U+1EE3 LATIN SMALL LETTER O WITH HORN AND DOT BELOW
	"Ụ" : 0x1001ee4,  # U+1EE4 LATIN CAPITAL LETTER U WITH DOT BELOW
	"ụ" : 0x1001ee5,  # U+1EE5 LATIN SMALL LETTER U WITH DOT BELOW
	"Ủ" : 0x1001ee6,  # U+1EE6 LATIN CAPITAL LETTER U WITH HOOK ABOVE
	"ủ" : 0x1001ee7,  # U+1EE7 LATIN SMALL LETTER U WITH HOOK ABOVE
	"Ứ" : 0x1001ee8,  # U+1EE8 LATIN CAPITAL LETTER U WITH HORN AND ACUTE
	"ứ" : 0x1001ee9,  # U+1EE9 LATIN SMALL LETTER U WITH HORN AND ACUTE
	"Ừ" : 0x1001eea,  # U+1EEA LATIN CAPITAL LETTER U WITH HORN AND GRAVE
	"ừ" : 0x1001eeb,  # U+1EEB LATIN SMALL LETTER U WITH HORN AND GRAVE
	"Ử" : 0x1001eec,  # U+1EEC LATIN CAPITAL LETTER U WITH HORN AND HOOK ABOVE
	"ử" : 0x1001eed,  # U+1EED LATIN SMALL LETTER U WITH HORN AND HOOK ABOVE
	"Ữ" : 0x1001eee,  # U+1EEE LATIN CAPITAL LETTER U WITH HORN AND TILDE
	"ữ" : 0x1001eef,  # U+1EEF LATIN SMALL LETTER U WITH HORN AND TILDE
	"Ự" : 0x1001ef0,  # U+1EF0 LATIN CAPITAL LETTER U WITH HORN AND DOT BELOW
	"ự" : 0x1001ef1,  # U+1EF1 LATIN SMALL LETTER U WITH HORN AND DOT BELOW
	"Ỵ" : 0x1001ef4,  # U+1EF4 LATIN CAPITAL LETTER Y WITH DOT BELOW
	"ỵ" : 0x1001ef5,  # U+1EF5 LATIN SMALL LETTER Y WITH DOT BELOW
	"Ỷ" : 0x1001ef6,  # U+1EF6 LATIN CAPITAL LETTER Y WITH HOOK ABOVE
	"ỷ" : 0x1001ef7,  # U+1EF7 LATIN SMALL LETTER Y WITH HOOK ABOVE
	"Ỹ" : 0x1001ef8,  # U+1EF8 LATIN CAPITAL LETTER Y WITH TILDE
	"ỹ" : 0x1001ef9,  # U+1EF9 LATIN SMALL LETTER Y WITH TILDE
	"Ơ" : 0x10001a0,  # U+01A0 LATIN CAPITAL LETTER O WITH HORN
	"ơ" : 0x10001a1,  # U+01A1 LATIN SMALL LETTER O WITH HORN
	"Ư" : 0x10001af,  # U+01AF LATIN CAPITAL LETTER U WITH HORN
	"ư" : 0x10001b0,  # U+01B0 LATIN SMALL LETTER U WITH HORN
    "ă" : 0x01e3,     # U+0103 LATIN SMALL LETTER A WITH BREVE */
    "Ă" : 0x01c3,     # U+0102 LATIN CAPITAL LETTER A WITH BREVE
    "Ỳ" : 0x1001ef2,  # U+1EF2 LATIN CAPITAL LETTER Y WITH GRAVE */
    "ỳ" : 0x1001ef3,  # U+1EF3 LATIN SMALL LETTER Y WITH GRAVE */
    "Đ" : 0x01d0,     # U+0110 LATIN CAPITAL LETTER D WITH STROKE
    "đ" : 0x01f0,     # U+0111 LATIN SMALL LETTER D WITH STROKE
    "Ĩ" : 0x03a5,     # U+0128 LATIN CAPITAL LETTER I WITH TILDE */
    "ĩ" : 0x03b5,     # U+0129 LATIN SMALL LETTER I WITH TILDE */
    "Ũ" : 0x03dd,     # U+0168 LATIN CAPITAL LETTER U WITH TILDE */
    "ũ" : 0x03fd,     # U+0169 LATIN SMALL LETTER U WITH TILDE
}
